public class ProdCons120k2 {
  public static void main(String[] args) {
    int n = 1000;
    Buffer b = new Buffer();

    Producer p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();
    
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();

    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();
    
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();

    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();
    
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();
    
        p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();
    
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();
    
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();
    
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);    
    p.start();
    p = new Producer(n, b);
    p.start();
    
    Consumer c = new Consumer(100 * n, b);
    c.start();

    try {
      p.join();
      c.join();
    } catch (InterruptedException e) {}
  }
}